
"""
Trait definitions in the 'scene' namespace.

Traits related to scene.
"""

# WARNING: This file is auto-generated by openassetio-traitgen, do not edit.

from typing import Union

from openassetio import TraitsData


class UsdTrait:
    """
    A trait indicating a USD file.
    Usage: entity
    """
    kId = "Ayon:scene.Usd"

    def __init__(self, traitsData):
        """
        Construct this trait view, wrapping the given data.

        @param traitsData @fqref{TraitsData}} "TraitsData" The target
        data that holds/will hold the traits properties.
        """
        self.__data = traitsData

    def isImbued(self):
        """
        Checks whether the data this trait has been applied to
        actually has this trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return self.isImbuedTo(self.__data)

    @classmethod
    def isImbuedTo(cls, traitsData):
        """
        Checks whether the given data actually has this trait.
        @param traitsData: Data to check for trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return traitsData.hasTrait(cls.kId)

    def imbue(self):
        """
        Adds this trait to the held data.

        If the data already has this trait, it is a no-op.
        """
        self.__data.addTrait(self.kId)

    @classmethod
    def imbueTo(cls, traitsData):
        """
        Adds this trait to the provided data.

        If the data already has this trait, it is a no-op.
        """
        traitsData.addTrait(cls.kId)

    


class WorkfileTrait:
    """
    A trait indicating a workfile.
    Usage: entity
    """
    kId = "Ayon:scene.Workfile"

    def __init__(self, traitsData):
        """
        Construct this trait view, wrapping the given data.

        @param traitsData @fqref{TraitsData}} "TraitsData" The target
        data that holds/will hold the traits properties.
        """
        self.__data = traitsData

    def isImbued(self):
        """
        Checks whether the data this trait has been applied to
        actually has this trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return self.isImbuedTo(self.__data)

    @classmethod
    def isImbuedTo(cls, traitsData):
        """
        Checks whether the given data actually has this trait.
        @param traitsData: Data to check for trait.
        @return `True` if the underlying data has this trait, `False`
        otherwise.
        """
        return traitsData.hasTrait(cls.kId)

    def imbue(self):
        """
        Adds this trait to the held data.

        If the data already has this trait, it is a no-op.
        """
        self.__data.addTrait(self.kId)

    @classmethod
    def imbueTo(cls, traitsData):
        """
        Adds this trait to the provided data.

        If the data already has this trait, it is a no-op.
        """
        traitsData.addTrait(cls.kId)

    
    def setHost(self, host: str):
        """
        Sets the host property.

        Name and version of the DCC that created this workfile.
        """
        if not isinstance(host, str):
            raise TypeError("host must be a 'str'.")
        self.__data.setTraitProperty(self.kId, "host", host)

    def getHost(self, defaultValue: str=None) -> Union[str, None]:
        """
        Gets the value of the host property or the supplied default.

        Name and version of the DCC that created this workfile.
        """
        value = self.__data.getTraitProperty(self.kId, "host")
        if value is None:
            return defaultValue

        if not isinstance(value, str):
            if defaultValue is None:
                raise TypeError(f"Invalid stored value type: '{type(value).__name__}' should be 'str'.")
            return defaultValue
        return value
        
    def setType(self, type: str):
        """
        Sets the type property.

        Type of the workfile - like Maya Binary, Maya ASCII, etc.
        """
        if not isinstance(type, str):
            raise TypeError("type must be a 'str'.")
        self.__data.setTraitProperty(self.kId, "type", type)

    def getType(self, defaultValue: str=None) -> Union[str, None]:
        """
        Gets the value of the type property or the supplied default.

        Type of the workfile - like Maya Binary, Maya ASCII, etc.
        """
        value = self.__data.getTraitProperty(self.kId, "type")
        if value is None:
            return defaultValue

        if not isinstance(value, str):
            if defaultValue is None:
                raise TypeError(f"Invalid stored value type: '{type(value).__name__}' should be 'str'.")
            return defaultValue
        return value
        
    

